import timeit
import numpy

def test1():
    n = 1000
    A = numpy.zeros((n, n))
    #for i in range(n-1):
    #    A[i,i+1] = 1.0
    #    A[i+1,i] = 1.0
    for i in range(n):
        for j in range(n):
            A[i,j] = j-i
    s = sum(numpy.dot(A, numpy.arange(n)))
    return s

def test2():
    n = 1000
    B = numpy.zeros((n, 2*n-1))
    B[:,:n] = numpy.arange(n)[numpy.newaxis,:]
    B[:,n:] = numpy.arange(-n+1, 0)[numpy.newaxis,:]
    #B[:,1] = 1.0
    #B[:,-1] = 1.0
    A = numpy.resize(B, (n, 2*n-2))[:,:n]
    s = sum(numpy.dot(A, numpy.arange(n)))
    return s

def run():
    for test in [ test1, test2 ]:
        print test()
    for name in [ "test1", "test2" ]:
        T = timeit.Timer("timings.%s()" % name, "import timings")
        print T.repeat(3, 1)

if __name__ == "__main__":
    run()
