# trapezoidal rule

import numpy

def trap_quad(f, a, b, n):
    h = (b - a) / n
    xs = [ a + h*i for i in range(1, n) ]
    s = sum([f(x) for x in xs])
    I = h/2.0 * f(a) + h * s + h/2.0 * f(b)
    return I

def trap_quad_array(f, a, b, n):
    h = (b - a) / n
    x = a + h * numpy.arange(n+1)
    y = f(x)
    y[0] /= 2.0
    y[n] /= 2.0
    return h * numpy.sum(y)

